﻿using System;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace txtReader
{
    public partial class Form1 : Form
    {
        private static int PageTotal = 0;
        private static int PageCurrent = 0;
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 打开文件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TsMenuOpen_Click(object sender, EventArgs e)
        {
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                PageCurrent = 0;
                ReadTxt();
            }
        }

        private void ReadTxt()
        {
            byte[] byts = new byte[decimal.ToInt32(numericUpDown2.Value)];
            using (var fs = File.OpenRead(ofd.FileName))
            {
                int MValue = decimal.ToInt32(numericUpDown2.Value);
                int ValueFrom = MValue * PageCurrent;
                fs.Position = ValueFrom;
                fs.Read(byts, 0, MValue);
                if (byts != null)
                {
                    int v = (int)((fs.Length / decimal.ToInt32(numericUpDown2.Value)) + 1);
                    PageTotal = v;
                    txtShow.Text = Encoding.Default.GetString(byts);
                }
                fs.Close();
            }
        }

        /// <summary>
        /// 保存文件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TxMenuSave_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "文本文件|*.txt";
            if (DialogResult.OK == sfd.ShowDialog())
            {
                using (StreamWriter sw = new StreamWriter(sfd.FileName, false, Encoding.Default))
                {
                    sw.WriteLine(txtShow.Text.Trim());
                    sw.Close();
                }
            }
        }
        /// <summary>
        /// 关闭文件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TxMenuClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        /// <summary>
        /// 首页
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnFirst_Click(object sender, EventArgs e)
        {
            PageCurrent = 0;
            ReadTxt();
        }
        /// <summary>
        /// 上一页
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnPagePre_Click(object sender, EventArgs e)
        {
            PageCurrent = PageCurrent > 0 ? PageCurrent - 1 : 0;
            ReadTxt();
        }
        /// <summary>
        /// 下一页
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnPageNext_Click(object sender, EventArgs e)
        {
            PageCurrent++;
            ReadTxt();
        }
        /// <summary>
        /// 尾页
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnPageEnd_Click(object sender, EventArgs e)
        {
            PageCurrent = PageTotal - 1;
            ReadTxt();
        }
        /// <summary>
        /// 跳转
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void BtnPageTo_Click(object sender, EventArgs e)
        {
            PageCurrent = decimal.ToInt32(numericUpDown1.Value);
            ReadTxt();
        }
    }
}
